%define kmodtool sh %{SOURCE49}
%define	kmod_name virtio
%define kverbase 2.4.21
%define kverrel %{kverbase}-60.EL
%define debug_package %{nil}

# hardcode for now 
%define kvariants smp ""
%define kbuilddep kernel-source

%ifarch i686
%define kvariants  hugemem smp ""
%endif

%ifarch ia32e
%define kvariants ""
%endif


# Need to define for virtio
%define virtio_src_rev 0.1

Name: virtio 
License: GPL
Group: System Environment/Kernel
Summary: virtio paravirtual drivers for RHEL-3
Version: 0.1
Release: 16.el3
Source0: virtio-%{virtio_src_rev}-src.tgz
Source3: README.el3
Source49: virtio-kmodtool-el3
ExclusiveArch:	i686 x86_64 athlon ia32e



# rhel-3 patches
Patch1: kvm-guest-drivers-linux-2.4.patch
Patch2: kvm-guest-drivers-linux-updates.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: kernel %kbuilddep

%description
Paravirtual drivers for Linux-KVM-based Full-Virt/HVM guests

%define kmp_version %{version}
%define kmp_release %{release}

%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
%setup -q -c

cd virtio-%{virtio_src_rev}-src

%patch1 -p1
%patch2 -p1

cp Makefile Makefile.orig
cp Makefile.kernel-2.4 Makefile
set -- *
mkdir source
mv "$@" source/
mkdir source/kernel

%build
ksrc=%{_usrsrc}/linux-%{kverrel}
# ok, now, to get to building virtio pv-on-hvm drivers...
cd virtio-%{virtio_src_rev}-src
virtiosrc=$PWD
for flavor in %kvariants;  do
	#
	# There is no kernel-devel pkg for RHEL-3,
	# only kernel-source, so need to copy kernel
	# tree (due to priv'd access to kernel src)
	# & make oldconfig & make dep, per-kvariant,
	# in order to build modules.
	#
	echo "### building for '$flavor' variant of kernel ###"
	kdir="kernels/%{kverrel}${flavor:+-$flavor}-%{_target_cpu}"
	rm -rf $virtiosrc/$kdir
	mkdir -p $virtiosrc/$kdir
	cd $virtiosrc/$kdir
	ksrcbuild=$PWD
	cp -rd $ksrc/* . 
        # get rid of 'custom' tag on EXTRAVERSION to make scripts cleaner below
	cp $ksrcbuild/Makefile $ksrcbuild/Makefile.pre-virtio-orig
	sed -e "s/custom/$flavor/" $ksrcbuild/Makefile.pre-virtio-orig > $ksrcbuild/Makefile
	# clean out any old junk
	# make clean  -- not good enough!
	make mrproper > /dev/null
	# copy appropriate config file to seed make oldconfig
	cp -v configs/kernel-%{kverbase}-%{_target_cpu}${flavor:+-$flavor}.config ./.config
	make oldconfig > /dev/null
	# now, make dep; generates a ton of warnings so output error to /dev/null as well
	make dep >& /dev/null
	# finally, onto building virtio modules
	cd $virtiosrc
	mdir="obj-$flavor"
	rm -rf obj-$flavor
	cp -r source obj-$flavor
	cd $mdir
	# next line turned on, following line turned off for build debug
	make -C $ksrcbuild SUBDIRS=$PWD modules
	# make %{?_smp_mflags} -C $ksrcbuild SUBDIRS=$PWD/$mdir modules
done

%install
rm -rf %{buildroot}
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=kernel/drivers/%{kmod_name}/
cd virtio-%{virtio_src_rev}-src
virtiosrcdir=$PWD
for flavor in %kvariants; do
	echo "### installing for '$flavor' variant of kernel ###"
	# debug
	#ls
	kdir="kernels/%{kverrel}${flavor:+-$flavor}-%{_target_cpu}"
	cd $virtiosrcdir/$kdir
	ksrcbuild=$PWD
	mdir="obj-$flavor/"
	make -C $ksrcbuild SUBDIRS=$virtiosrcdir/$mdir modules_install
	# INSTALL_MOD_DIR not working yet in this kernel version ...
	fix="%{buildroot}/lib/modules/%{kverrel}"
	mkdir -p ${fix}${flavor}/$INSTALL_MOD_DIR
	# copy from non-flavor kernel area to flavor-specific area
	cp -v ${fix}${flavor}/kernel/Lost/*.o ${fix}${flavor}/$INSTALL_MOD_DIR
	# TODO: -- delete /Lost to make rpm cleaner...
	rm -vrf ${fix}${flavor}/kernel/Lost
	# todo? rm the build directory ?
done

mkdir -p %{buildroot}/usr/share/doc/%{name}-%{version}-%{release}
cp -v %{SOURCE3} %{buildroot}/usr/share/doc/%{name}-%{version}-%{release}/README.el3

#%files
#%defattr(-,root,root)

%changelog
* Tue Sep 01 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-16
- Minor typo fixes in README and spec file

* Tue Sep 01 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-15
- Changed "Adding block devices" chapter
- Add "Linux swap partition chapter

* Mon Aug 31 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-14
- Fixed build smp/hugemem packages

* Mon Aug 31 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-13
- Fixed spec file to not generate debug rpm
- Add depmod call to postinstall script
- Kernel version updated to 2.4.21.60

* Tue Aug 25 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-12
- Fixed spec file to not generate empty virtio rpm

* Tue Aug 25 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-11
- Changed README file - not using negative logic

* Mon Aug 24 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-10
- modified rpm post-install script code creating block device nodes
- created disk nodes count increased to 15 disks with 15 partitions
- README file update concerning manual block device nodes creation

* Thu Aug 20 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-9
- README file update based on review Don's review comments
- Updated postinstall script to get correct major number of virtio_blk

* Tue Aug 18 2009 Mike Bonnet <mikeb@redhat.com> - 0.1-8
- hard-code the kernel verrel to 2.4.21-58.EL
 
* Tue Jun 30 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-7
- Add GSO/TSO information into README file

* Wed Jun 24 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-5
- Return ia32e platform support, add README comment concerning x86_64 platform

* Tue Jun 23 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-4
- Fixed kvariants variable handling

* Tue Jun 09 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-3
- Add dev nodes handling during rpm install/uninstall and removed ia32 platform

* Fri May 28 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-2
- Used kmod tool

* Thu May 28 2009 Miroslav Rezanina <mrezanin@redhat.com> - 0.1-1
- Updated spec to use 2.4.21-58.EL kernel version
- First version based on virtio backport package git commit
  ae1ae62c24d1eddd35424bb1c6ce614f460e4962 and linux-2.6 git commit
  908a7a16b852ffd618a9127be8d62432182d81b4, 2.6 to 2.4 patch provided by
  Marcello Tosatti and bugfix patch by Miroslav Rezanina
